﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using System.Runtime.InteropServices; // needed for DllImport
//using System.Text; // needed for StringBuilder Class
using System.IO;



namespace NIST_Type_8_Microsoft_CSharp
{
    public partial class Form1 : Form
    {
        private WSQImageLibraryNativeMethods32 WSQ_library_native_methods;

        private IntPtr bp;
        private System.Drawing.Bitmap b;
        private byte[] input_data_stream;
//        private byte[] input_data_stream2;
//        private byte[] output_data_stream;
//        private byte[] output_data_stream2;


        private Int32 type8_image_compression_type;
        private String result_string;
        private String save_type8_binary_field_filename;
        private String image_size_txt_file;

        private IntPtr type8_binary_field_ptr;
        private byte[] type8_binary_field;
        private Int32 type8_binary_field_length;


        private Int32 type8_image_width;
        private Int32 type8_image_height;



        public Form1()
        {
            InitializeComponent();



            WSQ_library_native_methods = new WSQImageLibraryNativeMethods32();

            type8_binary_field_ptr = IntPtr.Zero;

            comboBoxCompression.Items.Add("Uncompressed");
            comboBoxCompression.Items.Add("ANSI/EIA-538-1988 facsimile compression");
            comboBoxCompression.SelectedIndex = 0;

            textBoxWidth.Text = "0";
            textBoxHeight.Text = "0";

        }


        // To call functions from WSQ_library.dll
        // you can use the methods from wrapper class WSQImageLibraryNativeMethods
        // or you can use function prototypes provided below 

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr _CreateNISTType8BinaryFieldfromHBITMAP(IntPtr input_HBITMAP, int type8_binary_field_compression_type);

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr _CreateHBITMAPfromNISTType8BinaryField(Int32 type8_image_width, Int32 type8_image_height, Int32 type8_compression_type, [In] byte[] type8_input_byte_array, Int32 type8_input_byte_array_size);

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _ReadSizeOfNISTType8BinaryField();

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _ReadType8DataCompressionType();

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _ReadType8DataWidth();

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _ReadType8DataHeight();

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _SetNISTType8ImageColorInversion(Int32 in_uncompressed_type8_image_inverted, Int32 out_uncompressed_type8_image_inverted, Int32 in_compressed_type8_image_inverted, Int32 out_compressed_type8_image_inverted);


        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr _GenerateSerialNumber();

        [DllImport("WSQ_library.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 _UnlockWSQLibrary(String lpszAuthorizationCode);






        private void ConvertFromType8Button_Click(object sender, EventArgs e)
        {


            ConvertToType8Button.Enabled = false;
            ConvertFromType8Button.Enabled = false;
            buttonOpen.Enabled = false;
            buttonSave.Enabled = false;


            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "Type8 binary images|*.bin";

            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                ConvertToType8Button.Enabled = true;
                ConvertFromType8Button.Enabled = true;
                return;
            }


            image_size_txt_file = Path.ChangeExtension(ofd.FileName, ".txt");

            if (File.Exists(image_size_txt_file))
            {

                // Create an instance of StreamReader to read from a file.
                // The using statement also closes the StreamReader.
                using (StreamReader sr = new StreamReader(@image_size_txt_file))
                {
                    type8_image_compression_type = Convert.ToInt32(sr.ReadLine());  // type8_image_compression_type = int.Parse(sr.ReadLine())
                    type8_image_width = Convert.ToInt32(sr.ReadLine());
                    type8_image_height = Convert.ToInt32(sr.ReadLine());

                    textBoxWidth.Text = Convert.ToString(type8_image_width);
                    textBoxHeight.Text = Convert.ToString(type8_image_height);

                }
            }//if (File.Exists(image_size_txt_file)) 
            else
            {
                type8_image_width = Convert.ToInt32(textBoxWidth.Text);
                type8_image_height = Convert.ToInt32(textBoxHeight.Text);            
            }


   if((type8_image_width == 0) | (type8_image_height == 0))
   {
    MessageBox.Show("You must manually set the type8_image_width and type8_image_height and compression type of the image.");
    ConvertFromType8Button.Enabled = true;
    buttonOpen.Enabled = true;
    return;
   }


            comboBoxCompression.SelectedIndex = type8_image_compression_type;


            FileInfo fInfo = new FileInfo(ofd.FileName);
            long input_stream_length = fInfo.Length;
            FileStream fStream = new FileStream(ofd.FileName, FileMode.Open, FileAccess.Read);
            BinaryReader br = new BinaryReader(fStream);

            input_data_stream = br.ReadBytes((int)input_stream_length);
            br.Close();
            fStream.Close();


            bp = _CreateHBITMAPfromNISTType8BinaryField(type8_image_width, type8_image_height, type8_image_compression_type, input_data_stream, (int)input_stream_length);

            b = Image.FromHbitmap(bp);
            picture.Image = b;
            
            Int32 h = picture.Image.Height;
            Int32 w = picture.Image.Width;
            picture.SetBounds(0, 0, w, h);


            ConvertToType8Button.Enabled = true;
            ConvertFromType8Button.Enabled = true;
            buttonOpen.Enabled = true;
            buttonSave.Enabled = true;

        }

        private void ConvertToType8Button_Click(object sender, EventArgs e)
        {

            ConvertToType8Button.Enabled = false;
            ConvertFromType8Button.Enabled = false;


            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "BIN Files (*.bin)|*.bin";
            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                ConvertFromType8Button.Enabled = true;
                ConvertFromType8Button.Enabled = true;
                return;
            }


            type8_image_width = Convert.ToInt32(textBoxWidth.Text);
            type8_image_height = Convert.ToInt32(textBoxHeight.Text);
            type8_image_compression_type = comboBoxCompression.SelectedIndex;

            image_size_txt_file = Path.ChangeExtension(sfd.FileName, ".txt");


            using (System.IO.StreamWriter file = new System.IO.StreamWriter(@image_size_txt_file))
            {
                file.WriteLine(type8_image_compression_type.ToString());
                file.WriteLine(type8_image_width.ToString());
                file.WriteLine(type8_image_height.ToString());
            }


            b = new Bitmap(picture.Image);
            bp = b.GetHbitmap();

            save_type8_binary_field_filename = Path.ChangeExtension(sfd.FileName, ".bin");

            type8_binary_field_ptr = _CreateNISTType8BinaryFieldfromHBITMAP(bp, type8_image_compression_type);
	        type8_binary_field_length = _ReadSizeOfNISTType8BinaryField();

            //MessageBox.Show(type8_binary_field_length.ToString());

	        type8_binary_field = new byte[type8_binary_field_length];
	        Marshal.Copy(type8_binary_field_ptr, type8_binary_field, 0, type8_binary_field_length);

            FileStream fStream = new FileStream(save_type8_binary_field_filename, FileMode.Create);
	        BinaryWriter bw = new BinaryWriter(fStream);

	        bw.Write(type8_binary_field);
	        bw.Close();
	        fStream.Close();
           
            
            result_string = "The converted file was saved as:\n" + save_type8_binary_field_filename;
	        MessageBox.Show(result_string);

            ConvertToType8Button.Enabled = true;
            ConvertFromType8Button.Enabled = true;

        }

        private void buttonOpen_Click(object sender, EventArgs e)
        {

            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "All images|*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;" +
                "*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;" +
                "*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp;" +
                "|FBI Wavelet Scalar Quantization (*.wsq)|*.wsq" +
                "|Windows bitmaps (*.bmp)|*.bmp|Macintosh TIFF images (*.tiff)|*.tiff|PC TIFF images (*.tif)|*.tif" +
                "|JPG images (*.jpg)|*.jpg|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc|JPE images (*.jpe)|*.jpe" +
                "|JPEG images (*.jpeg)|*.jpeg|Portable network graphic images (*.png)|*.png" +
                "|Compuserve Graphic Interchange Format(*.gif)|*gif|Paintshop Pro images (*.psp)|*.psp|JFIF images (*.jfif)|*.jfif" +
                "|Run length encoded Windows bitmaps (*.rle)|*.rle|Device independant Windows bitmaps (*.dib)|*.dib" +
                "|Truevision images (*.win)|*.win|Truevision images (*.vst)|*.vst|Truevision images (*.vda)|*.vda" +
                "|Truevision images (*.tga)|*.tga|Truevision images (*.icb)|*.icb|GFI fax images (*.fax)|*.fax" +
                "|Encapsulated Postscript images (*.eps)|*.eps|ZSoft Paintbrush images (*.pcx)|*.pcx|ZSoft Paintbrush images (*.pcc)|*.pcc" +
                "|Word 5.x screen capture images (*.scr)|*.scr|Alias/Wavefront images (*.rpf)|*.rpf|Alias/Wavefront images (*.rla)|*.rla" +
                "|SGI true color images (*.sgi)|*.sgi|SGI true color images with alpha (*.rgba)|*.rgba|SGI true color images (*.rgb)|*.rgb" +
                "|SGI black/white images (*.bw)|*.bw|Photoshop images (*.psd)|*.psd|Photoshop images (*.pdd)|*.pdd" +
                "|Portable pixel map images (*.ppm)|*.ppm|Portable gray map images (*.pgm)|*.pgm|Portable bitmap images (*.pbm)|*.pbm" +
                "|Autodesk images (*.cel)|*.cel|Autodesk images (*.pic)|*.pic|Kodak Photo-CD images (*.pcd)|*.pcd" +
                "|Dr. Halo images (*.cut)|*.cut|Amiga Bitmap Graphic (8 bits)|*.iff|Windows icons (*.ico)|*.ico" +
                "|Windows metafiles (*.wmf)|*.wmf|Windows enhanced meta files (*.emf)|*.emf";

            ofd.FilterIndex = 1;
            if (ofd.ShowDialog() != DialogResult.OK)
            {
                return;
            }


            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //bp = _CreateBMPFromFile(ofd.FileName);
            bp = WSQ_library_native_methods.pCreateBMPFromFile(ofd.FileName);
            b = Image.FromHbitmap(bp);
            picture.Image = b;

            Int32 h = picture.Image.Height;
            Int32 w = picture.Image.Width;
            picture.SetBounds(0, 0, w, h);

            buttonSave.Enabled = true;
            ConvertToType8Button.Enabled = true;


        }

        private void buttonSave_Click(object sender, EventArgs e)
        {

            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "WSQ Files (*.wsq)|*.wsq|Windows BMP (*.bmp)|*.bmp|TIFF Files (*.tif)|*.tif" +
                "|PNG Files (*.png)|*.png|JPEG Files (*.jpg)|*.jpg|Targa Files (*.tga)|*.tga|SGI Files (*.rgb)|*.rgb" +
                "|JPEG-2000 Part-1 (*.jp2)|*.jp2|JPEG-2000 Code Stream (*.jpc)|*.jpc";
            sfd.FilterIndex = 1;
            if (sfd.ShowDialog() != DialogResult.OK)
            {
                return;
            }

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SetShowFilePropertiesDialog(1);
            WSQ_library_native_methods.pSetShowFilePropertiesDialog(1);


            b = new Bitmap(picture.Image);
            bp = b.GetHbitmap();

            //you can use commented line of code bellow or you can use method from class WSQ_library_native_methods
            //_SaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);
            WSQ_library_native_methods.pSaveBMPToFile(bp, sfd.FileName, sfd.FilterIndex);

        }
    }
}
